	include	"DoorsOS.h"
	include "userlib.h"


	xdef	_main
	xdef	_comment
	xdef	_ti92plus

;SetFont		MACRO
;	move.w		\1,-(a7)
;	jsr		doorsos::FontSetSys
;	lea		2(a7),a7
;		ENDM

WriteStrX	MACRO
	move.w		\3,-(a7)
	pea		\4
	move.w		\2,-(a7)
	move.w		\1,-(a7)
	jsr		doorsos::DrawStrXY
	lea		10(a7),a7
		ENDM

Line		MACRO
	move.w		\2,-(a7)
	move.w		\1,-(a7)
	jsr		_ROM_CALL_19D
	lea		4(a7),a7
	move.w		\4,-(a7)
	move.w		\3,-(a7)
	jsr		_ROM_CALL_19C
	lea		4(a7),a7
		ENDM

PutS		MACRO
	movem.l		d0-d2,-(a7)
	move.l		\1,d0
	move.l		\2,d1
	move.l		\3,d2
	bsr		PutSprite
	movem.l		(a7)+,d0-d2
		ENDM

PPut		MACRO
	movem.l		d0-d2,-(a7)
	clr.l		d0
	clr.l		d1
	move.b		Pcol,d0
	move.b		Prow,d1
	move.l		\1,d2
	bsr		PutSprite
	movem.l		(a7)+,d0-d2
		ENDM

Wait		MACRO
	move.l		d0,-(a7)
	move.l		\1,d0
	bsr		WaitFunc
	move.l		(a7)+,d0
		ENDM
;*****************************************************

_main:
	jsr		_ROM_CALL_19e		; New Game
	SetFont		#2
	WriteStrX	#25,#7,#1,_comment
	bsr		DrawField
	bra		CreateField
GameLoop:
	bra		CheckAround
chkdone:
	jsr		userlib::idle_loop
	cmp.w		#268,d0			; [F1]
	beq		_main			; New Game
	cmp.w		#264,d0			; [ESC]
	beq		Exit
	cmp.w		#338,d0			; [PadUp]
	beq		Up
	cmp.w		#340,d0			; [PadRight]
	beq		Right
	cmp.w		#344,d0			; [PadDown]
	beq		Down
	cmp.w		#337,d0			; [PadLeft]
	beq		Left
	cmp.w		#56,d0			; [8]
	beq		Up
	cmp.w		#57,d0			; [9]
	beq		RightUp
	cmp.w		#54,d0			; [6]
	beq		Right
	cmp.w		#51,d0			; [3]
	beq		RightDown
	cmp.w		#50,d0			; [2]
	beq		Down
	cmp.w		#49,d0			; [1]
	beq		LeftDown
	cmp.w		#52,d0			; [4]
	beq		Left
	cmp.w		#55,d0			; [7]
	beq		LeftUp
	bra		GameLoop

Exit:
	rts


Up:
	cmp.b		#0,Prow
	ble		GameLoop
	PPut		#0
	subq.b		#1,Prow
	PPut		#1
	bra		GameLoop
RightUp:
	cmp.b		#21,Pcol
	bge		GameLoop
	cmp.b		#0,Prow
	ble		GameLoop
	PPut		#0
	addq.b		#1,Pcol
	subq.b		#1,Prow
	PPut		#1
	bra		GameLoop
Right:
	cmp.b		#21,Pcol
	bge		GameLoop
	PPut		#0
	addq.b		#1,Pcol
	PPut		#1
	bra		GameLoop
RightDown:
	cmp.b		#21,Pcol
	bge		GameLoop
	cmp.b		#9,Prow
	bge		GameLoop
	PPut		#0
	addq.b		#1,Pcol
	addq.b		#1,Prow
	PPut		#1
	bra		GameLoop
Down:
	cmp.b		#9,Prow
	bge		GameLoop
	PPut		#0
	addq.b		#1,Prow
	PPut		#1
	bra		GameLoop
LeftDown:
	cmp.b		#0,Pcol
	ble		GameLoop
	cmp.b		#9,Prow
	bge		GameLoop
	PPut		#0
	subq.b		#1,Pcol
	addq.b		#1,Prow
	PPut		#1
	bra		GameLoop
Left:
	cmp.b		#0,Pcol
	ble		GameLoop
	PPut		#0
	subq.b		#1,Pcol
	PPut		#1
	bra		GameLoop
LeftUp:
	cmp.b		#0,Pcol
	ble		GameLoop
	cmp.b		#0,Prow
	ble		GameLoop
	PPut		#0
	subq.b		#1,Pcol
	subq.b		#1,Prow
	PPut		#1
	bra		GameLoop

PutSprite:
	movem.l		a0-a1,-(a7)
	lea		sprites(PC),a0
	lsl.l		#3,d2
	adda.l		d2,a0
	move.l		#LCD_MEM,a1
	adda.l		#724,a1
	adda.l		d0,a1
	mulu		#240,d1
	adda.l		d1,a1
	move.l		#7,d0
putloop:
	move.b		(a0)+,(a1)
	lea		30(a1),a1
	dbra		d0,putloop
	movem.l		(a7)+,a0-a1
	rts


DrawField:
	movem.l		d6-d7,-(a7)
	move.l		#22,d6
	move.l		#32,d7
fhloop:
	Line		d7,#24,d7,#104
	addq.l		#8,d7
	dbra		d6,fhloop
	move.l		#10,d6
	move.l		#24,d7
fvloop:
	Line		#32,d7,#208,d7
	addq.l		#8,d7
	dbra		d6,fvloop
	movem.l		(a7)+,d6-d7
	PutS		#0,#0,#1
	PutS		#21,#9,#2
	rts


CreateField:
	move.l		#307,-(a7)		; Clear field + vars
	move.w		#0,-(a7)
	pea		field
	jsr		doorsos::memset
	lea		10(a7),a7
cmenu:
	move.w 		#$FFFF,-(a7) 		;Window y position ($FFFF=center)
	move.w 		#$FFFF,-(a7)	 	;Window x position ($FFFF=center)
	pea 		menu(PC)		;Adress to fields structure
	jsr 		doorsos::MenuPopup 	;Activate window
	lea		8(a7),a7
	tst.w		d0
	beq		Exit			; Did player hit [ESC]
	mulu		#10,d0
	move.b		d0,Nummines		; Store number of mines
	move.l		d0,d7
	subq.l		#1,d7
cloop:
	move.l		#10,d0
	jsr		userlib::random
	move.w		d0,d1			; d1 = row
	move.l		#22,d0
	jsr		userlib::random		; d0 = col
	cmp.w		#0,d1
	bne		cok1
	cmp.w		#0,d0
	beq		cloop
cok1:
	cmp.w		#9,d1
	bne		cok2
	cmp.w		#21,d0
	beq		cloop
cok2:
	lea		field,a0
	adda.l		#25,a0
	mulu.w		#24,d1
	adda.w		d1,a0
	tst.b		0(a0,d0.w)
	bne		cloop
	move.b		#1,0(a0,d0.w)
	dbra		d7,cloop
	bra		GameLoop


PlotMines:
	clr.l		d0
	clr.l		d1
	move.l		#3,d2
	move.l		#9,d3
	lea		field,a0
	adda.l		#25,a0
ploop1:
	move.l		#21,d4
	clr.l		d0
ploop2:
	tst.b		(a0)+
	beq		pnone
	movem.l		d0-d2,-(a7)
	bsr		PutSprite
	movem.l		(a7)+,d0-d2
pnone:
	addq.l		#1,d0
	dbra		d4,ploop2
	addq.l		#1,d1
	adda.l		#2,a0
	dbra		d3,ploop1
	rts


CheckAround:
	lea		field,a0
	adda.l		#25,a0
	clr.l		d0
	move.b		Prow,d0
	mulu		#24,d0
	adda.l		d0,a0
	clr.l		d0
	move.b		Pcol,d0
	tst.b		0(a0,d0.w)
	beq		nobang
	WriteStrX	#75,#110,#4,str2
	bsr		PlotMines
	bsr		ShakeScreen
	jsr		userlib::idle_loop
	bra		_main
nobang:
	cmp.b		#9,Prow
	bne		nofinish
	cmp.b		#21,Pcol
	bne		nofinish
	WriteStrX	#75,#110,#4,str3
	bsr		PlotMines
	jsr		userlib::idle_loop
	bra		_main
nofinish:
	clr.l		d1
	tst.b		-25(a0,d0.w)
	beq		chnxt1
	addq.l		#1,d1
chnxt1:
	tst.b		-24(a0,d0.w)
	beq		chnxt2
	addq.l		#1,d1
chnxt2:
	tst.b		-23(a0,d0.w)
	beq		chnxt3
	addq.l		#1,d1
chnxt3:
	tst.b		1(a0,d0.w)
	beq		chnxt4
	addq.l		#1,d1
chnxt4:
	tst.b		25(a0,d0.w)
	beq		chnxt5
	addq.l		#1,d1
chnxt5:
	tst.b		24(a0,d0.w)
	beq		chnxt6
	addq.l		#1,d1
chnxt6:
	tst.b		23(a0,d0.w)
	beq		chnxt7
	addq.l		#1,d1
chnxt7:
	tst.b		-1(a0,d0.w)
	beq		chnxt8
	addq.l		#1,d1
chnxt8:
	move.l		d1,-(a7)
	SetFont		#1
	move.l		(a7)+,d1
	move.w		d1,-(a7)
	pea		str1(PC)
	pea		buffer
	jsr		doorsos::sprintf
	lea		10(a7),a7
	WriteStrX	#75,#110,#4,buffer
	bra		chkdone


ShakeScreen:
	move.l		#6,d7
sloop:
	move.l		#3450,-(a7)
	move.l		#LCD_MEM+120,-(a7)
	move.l		#LCD_MEM+180,-(a7)
	jsr		doorsos::memmove
	lea		12(a7),a7
	Wait		#$FFFFFFFF
	move.l		#3450,-(a7)
	move.l		#LCD_MEM+180,-(a7)
	move.l		#LCD_MEM+120,-(a7)
	jsr		doorsos::memmove
	lea		12(a7),a7
	Wait		#$FFFFFFFF
	dbra		d7,sloop
	rts



WaitFunc:
	dbra		d0,WaitFunc
	rts


;*****************************************************

menu 		dc.w 	item1-menu 		; Offset to first item
		dc.w 	$0025 			; Menu type
		dc.w 	$0005 			; Total items
		dc.b 	$00 			; Max width (0=width of longest string)
		dc.b 	$53 			; Max height
		dc.w 	$0005 			; Main items
		ds.w 	3
		dc.l 	$FFFFFFFF
		dc.w 	$8001,item1-item1,$8002,item2-item1,$8003,item3-item1
		dc.w	$8004,item4-item1,$8005,item5-item1
		dc.l 	$FFFFFFFF

item1	 	dc.b	"10 Mines (Very Easy)",0
item2	 	dc.b 	"20 Mines (Easy)",0
item3	 	dc.b 	"30 Mines (Normal)",0
item4	 	dc.b 	"40 Mines (Hard)",0
item5	 	dc.b 	"50 Mines (Very Hard)",0

sprites:
		dc.b	%11111111	; Nr 0
		dc.b	%11111111
		dc.b	%11111111
		dc.b	%11111111
		dc.b	%11111111
		dc.b	%11111111
		dc.b	%11111111
		dc.b	%11111111

		dc.b	%11111111	; Nr 1
		dc.b	%11111111
		dc.b	%11100011
		dc.b	%11000001
		dc.b	%11000001
		dc.b	%11000001
		dc.b	%11100011
		dc.b	%11111111

		dc.b	%11111111	; Nr 2
		dc.b	%11111111
		dc.b	%11000001
		dc.b	%11011101
		dc.b	%11010101
		dc.b	%11011101
		dc.b	%11000001
		dc.b	%11111111

		dc.b	%11111111	; Nr 3
		dc.b	%11000001
		dc.b	%10100010
		dc.b	%10010100
		dc.b	%10001000
		dc.b	%10010100
		dc.b	%10100010
		dc.b	%11000001


str1		dc.b	"Near %d Mine(s)",0
str2		dc.b	"  Game Over!  ",0
str3		dc.b	"  Good Job!   ",0
_comment	dc.b	"Minehunt 1.0 - MarkuSoft",0

	bss

field		ds.b	288
buffer		ds.b	16
Pcol		dc.b	0
Prow		dc.b	0
Nummines	dc.b	0

;*****************************************************

	end
